/*
 * 	---------------- MoJo engine --------------
 *   		---- Basic Game Engine ----
 *
 * Author: Yann PARMENTIER <kohai@kohaistyle.com>
 *
 * ALL RIGHTS RESERVED
 *
 *	Uses
 * 			DMFloader  		( www.delgine.com )
 * 			GLFW 				( glfw.sourceforge.net )
 *			Fmod Sound API 		( www.fmod.org )
 *
 * To compile this project you must include the following libraries:
 * wlib.lib uuid.lib fmodlcc.lib glfw.lib glu32.lib ole32.lib olepro32.lib opengl32.lib
 * You need also the header file glfw.h in your GL/ compiler directory.
 *
 * File header: mojoFont.c
 *
 */





//#include <gl/gl.h>
#include 	<windows.h>
#include 	<gl/glfw.h>
#include 	<GL/glext.h>
#include 	"mojofont.h"
#include 	"gltexfont.h"



extern 	PFNGLMULTITEXCOORD2FARBPROC     glMultiTexCoord2fARB;
extern	PFNGLACTIVETEXTUREARBPROC		glActiveTextureARB;


GLvoid mojoFontInit(GLint texture)								// Build Our Font Display List
{
	// ==========================================================================================
	// INITIALIZE THE FONT
	// ==========================================================================================
	float	cx;											// Holds Our X Character Coord
	float	cy;											// Holds Our Y Character Coord

	base=glGenLists(256);								// Creating 256 Display Lists
	glBindTexture(GL_TEXTURE_2D, texture);				// Select Our Font Texture
	for (loop=0; loop<256; loop++)						// Loop Through All 256 Lists
	{
		cx=(float)(loop%16)/16.0f;						// X Position Of Current Character
		cy=(float)(loop/16)/16.0f;						// Y Position Of Current Character

		glNewList(base+loop,GL_COMPILE);				// Start Building A List
			glBegin(GL_QUADS);							// Use A Quad For Each Character
				glTexCoord2f( cx, 1-cy-0.06f);			// Texture Coord (Bottom Left)
				glVertex2i(0,0);													// Vertex Coord (Bottom Left)
				glTexCoord2f( cx+0.06f, 1-cy-0.06f);// Texture Coord (Bottom Right)
				glVertex2i(16,0);													// Vertex Coord (Bottom Right)
				glTexCoord2f( cx+0.06f, 1-cy);		// Texture Coord (Top Right)
				glVertex2i(16,16);													// Vertex Coord (Top Right)
				glTexCoord2f(cx,1-cy);					// Texture Coord (Top Left)
				glVertex2i(0,16);						// Vertex Coord (Top Left)
			glEnd();									// Done Building Our Quad (Character)
			glTranslated(12,0,0);						// Move To The Right Of The Character
		glEndList();									// Done Building The Display List
	}													// Loop Until All 256 Are Built
}

//glMultiTexCoord2fARB( GL_TEXTURE0_ARB,


GLvoid mojoFontKill(GLint texture)						// Delete The Font From Memory
{
	glDeleteLists(base,256);							// Delete All 256 Display Lists
}



GLvoid mojoGlPrint(GLint x, GLint y, char *string, int set, float scale)	// Where The Printing Happens
{
/*	if (set>1)
	{
		set=1;
	}

	glDisable(GL_DEPTH_TEST);							// Disables Depth Testing
   	glDisable(GL_CULL_FACE); 		   					// Enable back face culling

   	glLoadIdentity();
	glTranslated(x,y,0);								// Position The Text (0,0 - Bottom Left)
	glScalef( scale, (scale/3.0)*4.0, 1.0);
	glListBase(base-32+(128*set));						// Choose The Font Set (0 or 1)
	glCallLists(strlen(string),GL_BYTE,string);			// Write The Text To The Screen
	glScalef( 1.0, 1.0, 1.0);

	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
   	glEnable(GL_CULL_FACE); 		   	// Enable back face culling
*/

		fontSize (scale);
		fontColor (1.0, 1.0, 1.0);
		//fontGradient ();
		//fontGradientColor (0.75, 0.5, 0.5);
		fontDrawString (x, y, string);


}


GLvoid mojoGlPrintCenter(float screenwidth, GLint y, char *string, int set, float scale)	// Where The Printing Happens
{

	float x;
/*
	if (set>1)
	{
		set=1;
	}

	glDisable(GL_DEPTH_TEST);							// Disables Depth Testing
   	glDisable(GL_CULL_FACE); 		   					// Enable back face culling

	x = (screenwidth - strlen(string)*(12.0*scale))/2.0;
   	glLoadIdentity();
	glTranslated(x,y,0);								// Position The Text (0,0 - Bottom Left)
	glScalef( scale, (scale/3.0)*4.0, 1.0);
	glListBase(base-32+(128*set));						// Choose The Font Set (0 or 1)
	glCallLists(strlen(string),GL_BYTE,string);			// Write The Text To The Screen
	glScalef( 1.0, 1.0, 1.0);

	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
   	glEnable(GL_CULL_FACE); 		   	// Enable back face culling
*/

		x = (screenwidth - strlen(string)*(scale))/2.0;

		fontSize (scale);
		fontColor (1.0, 1.0, 1.0);
		//fontGradient ();
		//fontGradientColor (0.75, 0.5, 0.5);
		fontDrawString (x, y, string);


}




GLvoid mojoGlPrintLoading(float screenwidth, GLint y, char *string, int font, int set, float scale)	// Where The Printing Happens
{
/*
		glActiveTextureARB( GL_TEXTURE1_ARB );
		glDisable(GL_BLEND);
		glDisable (GL_TEXTURE_2D);

		glActiveTextureARB( GL_TEXTURE0_ARB );
		glEnable(GL_TEXTURE_2D);
		glEnable(GL_BLEND);
		glBlendFunc(GL_ONE, GL_ONE);

		glBindTexture( GL_TEXTURE_2D, font );
		glColor3f(1.0,1.0,1.0);					// for colored font, we should use alpha testing
*/

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); // This clear the background
	mojoGlPrintCenter( screenwidth, y, string, set, scale);

   	glfwSwapBuffers(); 					// In double buffered mode we invert the positions



}


