//#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <GL/glfw.h>

#include "mojovector.h"
#include "mojomatrix.h"

/* I'm not 100% sure this module is completely debugged,
 * since I havent used it in any of my own projets yet
 * just give thanks I can be bothered to do this kind of thing
 * at all
 */

#define USE_OPENGL_ROTATION         1
#define OPTIMIZED_ROTATE_PRIMITIVES 1

__inline void MatrixLoadIdentity(MATRIX *m) {
  m->m[0]=1.0f;
  m->m[1]=0.0f;
  m->m[2]=0.0f;
  m->m[3]=0.0f;

  m->m[4]=0.0f;
  m->m[5]=1.0f;
  m->m[6]=0.0f;
  m->m[7]=0.0f;

  m->m[8]=0.0f;
  m->m[9]=0.0f;
  m->m[10]=1.0f;
  m->m[11]=0.0f;

  m->m[12]=0.0f;
  m->m[13]=0.0f;
  m->m[14]=0.0f;
  m->m[15]=1.0f;
}


__inline void MatrixLoadNull(MATRIX *m) {
  m->m[0]=1.0f;
  m->m[1]=0.0f;
  m->m[2]=0.0f;
  m->m[3]=0.0f;

  m->m[4]=0.0f;
  m->m[5]=1.0f;
  m->m[6]=0.0f;
  m->m[7]=0.0f;

  m->m[8]=0.0f;
  m->m[9]=0.0f;
  m->m[10]=1.0f;
  m->m[11]=0.0f;

}


/* Module for supporting 4x4 matrix's */
__inline void MatrixLoadGLModelview(MATRIX *m) {
  glGetFloatv(GL_MODELVIEW_MATRIX, (float*)m->m);
}

__inline void MatrixLoadGLProjection(MATRIX *m) {
  glGetFloatv(GL_PROJECTION_MATRIX, (float*)m->m);
}

/*
 * Generate a 4x4 transformation matrix from glRotate parameters.
 */
/* Blatantly ripped from Mesa strictly for demonstration purposes */
__inline void MatrixLoadRotation(MATRIX *m, float x, float y, float z, float angle) {
  float mag, s, c;
  float xx, yy, zz, xy, yz, zx, xs, ys, zs, one_minus_c;

  s = (float)sin( RADIAN(angle) );
  c = (float)cos( RADIAN(angle) );

  mag = (float) sqrt( x*x + y*y + z*z );

  if (mag == 0.0f) {
    MatrixLoadIdentity(m);
    return;
  }

  mag = 1.0f / mag;
  x *= mag;
  y *= mag;
  z *= mag;

  xx = x * x;
  yy = y * y;
  zz = z * z;
  xy = x * y;
  yz = y * z;
  zx = z * x;
  xs = x * s;
  ys = y * s;
  zs = z * s;
  one_minus_c = 1.0F - c;

  #define M(row,col) m->m[col*4+row]

  M(0,0) = (one_minus_c * xx) + c;
  M(0,1) = (one_minus_c * xy) - zs;
  M(0,2) = (one_minus_c * zx) + ys;
  M(0,3) = 0.0F;

  M(1,0) = (one_minus_c * xy) + zs;
  M(1,1) = (one_minus_c * yy) + c;
  M(1,2) = (one_minus_c * yz) - xs;
  M(1,3) = 0.0F;

  M(2,0) = (one_minus_c * zx) - ys;
  M(2,1) = (one_minus_c * yz) + xs;
  M(2,2) = (one_minus_c * zz) + c;
  M(2,3) = 0.0F;

  M(3,0) = 0.0F;
  M(3,1) = 0.0F;
  M(3,2) = 0.0F;
  M(3,3) = 1.0F;

#undef M
}

/*
 * load the current overall 3d transformation matrix
 */
__inline void MatrixLoadGLTransform(MATRIX *m) {
  MATRIX n;

  /* vertices are transformed by:
   * 1) Model view Matrix
   * 2) Projection Matrix
   */
  MatrixLoadGLModelview(m);
  MatrixLoadGLProjection(&n);
  MatrixMultiply(m, &n); // or is it the other way around?
}

__inline void MatrixCopy(MATRIX *m, MATRIX *n) {
  m->m[0 ] = n->m[0 ];
  m->m[1 ] = n->m[1 ];
  m->m[2 ] = n->m[2 ];
  m->m[3 ] = n->m[3 ];
  m->m[4 ] = n->m[4 ];
  m->m[5 ] = n->m[5 ];
  m->m[6 ] = n->m[6 ];
  m->m[7 ] = n->m[7 ];
  m->m[8 ] = n->m[8 ];
  m->m[9 ] = n->m[9 ];
  m->m[10] = n->m[10];
  m->m[11] = n->m[11];
  m->m[12] = n->m[12];
  m->m[13] = n->m[13];
  m->m[14] = n->m[14];
  m->m[15] = n->m[15];
}

/* This can probably be optimized by dropping
 * calculations for elements 3,7,11,15 because
 * they are discarded in 3D calcs
 * (ie they are allways equal to 0,0,0,1 respectively)
 */
__inline void MatrixMultiply(MATRIX *m, MATRIX *n) {
  MATRIX t;

  MatrixCopy(&t, m);
  m->m[0] = t.m[0 ]*n->m[0 ]
          + t.m[4 ]*n->m[1 ]
          + t.m[8 ]*n->m[2 ]
          + t.m[12]*n->m[3 ];

  m->m[1] = t.m[1 ]*n->m[0 ]
          + t.m[5 ]*n->m[1 ]
          + t.m[9 ]*n->m[2 ]
          + t.m[13]*n->m[3 ];

  m->m[2] = t.m[2 ]*n->m[0 ]
          + t.m[6 ]*n->m[1 ]
          + t.m[10]*n->m[2 ]
          + t.m[14]*n->m[3 ];

  m->m[3] = t.m[3 ]*n->m[0 ]
          + t.m[7 ]*n->m[1 ]
          + t.m[11]*n->m[2 ]
          + t.m[15]*n->m[3 ];

  m->m[4] = t.m[0 ]*n->m[4 ]
          + t.m[4 ]*n->m[5 ]
          + t.m[8 ]*n->m[6 ]
          + t.m[12]*n->m[7 ];

  m->m[5] = t.m[1 ]*n->m[4 ]
          + t.m[5 ]*n->m[5 ]
          + t.m[9 ]*n->m[6 ]
          + t.m[13]*n->m[7 ];

  m->m[6] = t.m[2 ]*n->m[4 ]
          + t.m[6 ]*n->m[5 ]
          + t.m[10]*n->m[6 ]
          + t.m[14]*n->m[7 ];

  m->m[7] = t.m[3 ]*n->m[4 ]
          + t.m[7 ]*n->m[5 ]
          + t.m[11]*n->m[6 ]
          + t.m[15]*n->m[7 ];

  m->m[8] = t.m[0 ]*n->m[8 ]
          + t.m[4 ]*n->m[9 ]
          + t.m[8 ]*n->m[10]
          + t.m[12]*n->m[11];

  m->m[9] = t.m[1 ]*n->m[8 ]
          + t.m[5 ]*n->m[9 ]
          + t.m[9 ]*n->m[10]
          + t.m[13]*n->m[11];

  m->m[10]= t.m[2 ]*n->m[8 ]
          + t.m[6 ]*n->m[9 ]
          + t.m[10]*n->m[10]
          + t.m[14]*n->m[11];

  m->m[11]= t.m[3 ]*n->m[8 ]
          + t.m[7 ]*n->m[9 ]
          + t.m[11]*n->m[10]
          + t.m[15]*n->m[11];

  m->m[12]= t.m[0 ]*n->m[12]
          + t.m[4 ]*n->m[13]
          + t.m[8 ]*n->m[14]
          + t.m[12]*n->m[15];

  m->m[13]= t.m[1 ]*n->m[12]
          + t.m[5 ]*n->m[13]
          + t.m[9 ]*n->m[14]
          + t.m[13]*n->m[15];

  m->m[14]= t.m[2 ]*n->m[12]
          + t.m[6 ]*n->m[13]
          + t.m[10]*n->m[14]
          + t.m[14]*n->m[15];

  m->m[15]= t.m[3 ]*n->m[12]
          + t.m[7 ]*n->m[13]
          + t.m[11]*n->m[14]
          + t.m[15]*n->m[15];

}

/* Quick hack not sure if it will work with all matrices, but
 * it will work with rotation + translation matrices
 */
__inline void MatrixInverse(MATRIX *m) {
  MATRIX n;

  MatrixCopy(&n, m);
  m->m[0 ] = n.m[0 ];
  m->m[1 ] = n.m[4 ];
  m->m[2 ] = n.m[8 ];

  m->m[4 ] = n.m[1 ];
  m->m[5 ] = n.m[5 ];
  m->m[6 ] = n.m[9 ];

  m->m[8 ] = n.m[2 ];
  m->m[9 ] = n.m[6 ];
  m->m[10] = n.m[10];

  m->m[12] *= -1.0f;
  m->m[13] *= -1.0f;
  m->m[14] *= -1.0f;
}

__inline void MatrixTranspose(MATRIX *m) {
  MATRIX n;

  MatrixCopy(&n, m);
  m->m[0 ] = n.m[0 ];
  m->m[1 ] = n.m[4 ];
  m->m[2 ] = n.m[8 ];
  m->m[3 ] = n.m[12];

  m->m[4 ] = n.m[1 ];
  m->m[5 ] = n.m[5 ];
  m->m[6 ] = n.m[9 ];
  m->m[7 ] = n.m[13];

  m->m[8 ] = n.m[2 ];
  m->m[9 ] = n.m[6 ];
  m->m[10] = n.m[10];
  m->m[11] = n.m[14];

  m->m[12] = n.m[3 ];
  m->m[13] = n.m[7 ];
  m->m[14] = n.m[11];
  m->m[15] = n.m[15];
}

/* Find the X' axis of the following matrix
 * ie the axis that the objects x axis is mapped to.
 */
__inline VECTOR *MatrixGetXPrime(MATRIX *m) {
  return (VECTOR*) &m->m[0];
}

/* Find the X' axis of the following matrix
 * ie the axis that the objects x axis is mapped to.
 */
__inline VECTOR *MatrixGetYPrime(MATRIX *m) {
  return (VECTOR*) &m->m[4];
}

/* Find the X' axis of the following matrix
 * ie the axis that the objects x axis is mapped to.
 */
__inline VECTOR *MatrixGetZPrime(MATRIX *m) {
  return (VECTOR*) &m->m[8];
}

/* find the vector that represents a matrixes position in space */
__inline VECTOR *MatrixGetTranslation(MATRIX *m) {
  return (VECTOR*) &m->m[12];
}

  /* This should be done via quaternions myself but lets cheat just for now
   * As I probably dont need to mention this is seriously bad performance-wise
   * it stalls the geometry pipeline and adds a couple extraneous matrix
   * copies to boot. OpenGL's version seems to optimize better anyways.
   */
__inline void MatrixRotate(MATRIX *m, float x, float y, float z, float angle) {
#if (!USE_OPENGL_ROTATION)
  MATRIX rotate;

  MatrixLoadRotation(&rotate, x, y, z, angle);
  MatrixMultiply(m, &rotate);
#else
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glLoadMatrixf((float*)m->m);
  glRotatef(angle, x, y, z);
  MatrixLoadGLModelview(m);
  glPopMatrix();
#endif
}

/* roll about the matrixes x axis - like an airplane */
__inline void MatrixYaw(MATRIX *m, float yaw) {
  MatrixRotate(m, m->m[4], m->m[5], m->m[6], yaw);
}

/* roll about the matrixes y axis - like an airplane  */
__inline void MatrixPitch(MATRIX *m, float pitch) {
  MatrixRotate(m, m->m[0], m->m[1], m->m[2], pitch);
}

/* roll about the matrixes z axis - like an airplane */
__inline void MatrixRoll(MATRIX *m, float roll) {
  MatrixRotate(m, m->m[8], m->m[9], m->m[10], roll);
}

/* This could be optimized */
__inline void MatrixRotateX(MATRIX *m, float angle) {
#if OPTIMIZED_ROTATE_PRIMITIVES
  float   s;
  float   c;
  MATRIX  t;

  /* setup */
  MatrixCopy(&t, m);
  s = (float)sin( RADIAN(angle) );
  c = (float)cos( RADIAN(angle) );

  m->m[4] = t.m[4 ]*c
          + t.m[8 ]*s;

  m->m[5] = t.m[5 ]*c
          + t.m[9 ]*s;

  m->m[6] = t.m[6 ]*c
          + t.m[10]*s;

  m->m[7] = t.m[7 ]*c
          + t.m[11]*s;

  m->m[8] = t.m[4 ]*-s
          + t.m[8 ]*c;

  m->m[9] = t.m[5 ]*-s
          + t.m[9 ]*c;

  m->m[10]= t.m[6 ]*-s
          + t.m[10]*c;

  m->m[11]= t.m[7 ]*-s
          + t.m[11]*c;

#else
  MatrixRotate(m, 1.0f, 0.0f, 0.0f, angle);
#endif
}

__inline void MatrixRotateY(MATRIX *m, float angle) {
#if OPTIMIZED_ROTATE_PRIMITIVES
  float   s;
  float   c;
  MATRIX  t;

  /* setup */
  MatrixCopy(&t, m);
  s = (float)sin( RADIAN(angle) );
  c = (float)cos( RADIAN(angle) );

  m->m[0] = t.m[0 ]*c
          + t.m[8 ]*-s;

  m->m[1] = t.m[1 ]*c
          + t.m[9 ]*-s;

  m->m[2] = t.m[2 ]*c
          + t.m[10]*-s;

  m->m[3] = t.m[3 ]*c
          + t.m[11]*-s;

  m->m[8] = t.m[0 ]*s
          + t.m[8 ]*c;

  m->m[9] = t.m[1 ]*s
          + t.m[9 ]*c;

  m->m[10]= t.m[2 ]*s
          + t.m[10]*c;

  m->m[11]= t.m[3 ]*s
          + t.m[11]*c;

#else
  MatrixRotate(m, 0.0f, 1.0f, 0.0f, angle);
#endif
}

__inline void MatrixRotateZ(MATRIX *m, float angle) {
#if OPTIMIZED_ROTATE_PRIMITIVES
  float   s;
  float   c;
  MATRIX  t;

  /* setup */
  MatrixCopy(&t, m);
  s = (float)sin( RADIAN(angle) );
  c = (float)cos( RADIAN(angle) );

  m->m[0] = t.m[0 ]*c
          + t.m[4 ]*s;

  m->m[1] = t.m[1 ]*c
          + t.m[5 ]*s;

  m->m[2] = t.m[2 ]*c
          + t.m[6 ]*s;

  m->m[3] = t.m[3 ]*c
          + t.m[7 ]*s;

  m->m[4] = t.m[0 ]*-s
          + t.m[4 ]*c;

  m->m[5] = t.m[1 ]*-s
          + t.m[5 ]*c;

  m->m[6] = t.m[2 ]*-s
          + t.m[6 ]*c;

  m->m[7] = t.m[3 ]*-s
          + t.m[7 ]*c;

#else
  MatrixRotate(m, 0.0f, 0.0f, 1.0f, angle);
#endif
}

__inline void MatrixTranslate(MATRIX *m, float x, float y, float z) {
  m->m[12] += x;
  m->m[13] += y;
  m->m[14] += z;
}

/* I dont think you'll want to be calling this ever but here it is
 * for completeness's sake
 */
__inline void MatrixScale(MATRIX *m, float x, float y, float z) {
  m->m[0 ] *= x;
  m->m[1 ] *= y;
  m->m[2 ] *= z;

  m->m[4 ] *= x;
  m->m[5 ] *= y;
  m->m[6 ] *= z;

  m->m[8 ] *= x;
  m->m[9 ] *= y;
  m->m[10] *= z;
}

/* Renormalize the rotation vectors, over time I believe the can become
 * inaccurate due to accumulative fp inaccuracy
 */
__inline void MatrixNormalize(MATRIX *m) {
  VectorNormalize( MatrixGetXPrime(m) );
  VectorNormalize( MatrixGetYPrime(m) );
  VectorNormalize( MatrixGetZPrime(m) );
}

__inline float MatrixGetYaw(MATRIX *m) {
  return VectorGetYaw( MatrixGetZPrime(m) );
}

__inline float MatrixGetPitch(MATRIX *m) {
  return VectorGetPitch( MatrixGetZPrime(m) );
}

__inline float MatrixGetRoll(MATRIX *m) {
  return VectorGetRoll( MatrixGetZPrime(m) );
}
