// Mini systeme de particules -> fichier principal
#include <GL/glfw.h>
#include <math.h>

#include <stdlib.h>
#include "mojoparticules.h"


// Globales
int particules_start, particules_stop = 0;

/********************************************************************************
 * Fonctions internes au systeme                                                *
 ********************************************************************************/
float bb_rg_x,bb_rg_y,bb_rg_z;
float bb_up_x,bb_up_y,bb_up_z;

void Prepare_Billboarding( void )
{
    float mat[16];

	// get current matrix
	glGetFloatv(GL_MODELVIEW_MATRIX, mat);

	// take right & up vectors
	bb_rg_x = mat[0];
	bb_rg_y = mat[4];
	bb_rg_z = mat[8];
	bb_up_x = mat[1];
	bb_up_y = mat[5];
	bb_up_z = mat[9];
}

void QuadBillboarded(float Size, float x, float y, float z)
{
	float ax,ay,az;
	float bx,by,bz;
	float cx,cy,cz;
	float dx,dy,dz;

	// make new vertexes
	ax = x + ((-bb_rg_x - bb_up_x) * Size);
	ay = y + ((-bb_rg_y - bb_up_y) * Size);
	az = z + ((-bb_rg_z - bb_up_z) * Size);

	bx = x + ((bb_rg_x - bb_up_x) * Size);
	by = y + ((bb_rg_y - bb_up_y) * Size);
	bz = z + ((bb_rg_z - bb_up_z) * Size);

	cx = x + ((bb_rg_x + bb_up_x) * Size);
	cy = y + ((bb_rg_y + bb_up_y) * Size);
	cz = z + ((bb_rg_z + bb_up_z) * Size);

	dx = x + ((-bb_rg_x + bb_up_x) * Size);
	dy = y + ((-bb_rg_y + bb_up_y) * Size);
	dz = z + ((-bb_rg_z + bb_up_z) * Size);

	// draw quad
	glBegin( GL_QUADS );

		glTexCoord2f( 0.0f, 0.0f ); glVertex3f( ax, ay, az );
		glTexCoord2f( 0.0f, 1.0f ); glVertex3f( bx, by, bz );
		glTexCoord2f( 1.0f, 1.0f ); glVertex3f( cx, cy, cz );
		glTexCoord2f( 1.0f, 0.0f ); glVertex3f( dx, dy, dz );

	glEnd();
}
/********************************************************************************
 * Fin Fonctions internes au systeme                                            *
 ********************************************************************************/

// Enfin le systeme de particules bancal de pp Stv :))))
void Init_Particles(struct m_particles *p)
{
	int loop;

	for(loop=0; loop<=128000; loop++) {
		// positions
		p[loop].posx = 0.f;
		p[loop].posy = 0.f;
		p[loop].posz = 0.f;

		// velocite
		p[loop].velx = 0.f;
		p[loop].vely = 0.f;
		p[loop].velz = 0.f;

		// couleurs
		p[loop].r = p[loop].g = p[loop].b = p[loop].a = 0.f;

		// gravit
		p[loop].gravity = 0.f;
	}
}

void Generate_Particles(struct m_particles *p,
						float x, float y, float z,
						float r, float g, float b, float a)
{
	int loop = 0;

	// Technique du vieux siou "je fais des for() a la mords moi le sboub :)))" mais ca marche ....
	for(loop=500; loop>=0; loop--) {


		p[particules_stop].posx = x;
		p[particules_stop].posy = y;
		p[particules_stop].posz = z;

		p[particules_stop].velx = (float)(200-rand()%400)/1000.f;
		p[particules_stop].vely = (float)(200-rand()%400)/1000.f;
		p[particules_stop].velz = (float)(200-rand()%400)/1000.f;

		p[particules_stop].r = r;
		p[particules_stop].g = g;
		p[particules_stop].b = b;
		p[particules_stop].a = a;

		particules_stop++;
	}

}

void Draw_Particles(struct m_particles *p)
{
	int i;


	Prepare_Billboarding();

	for(i=particules_start; i<particules_stop; i++) {

		if (p[i].r > 0.f) p[i].r -= 0.0005f; if (p[i].r < 0.f) p[i].r = 0.f;
		if (p[i].g > 0.f) p[i].g -= 0.0005f; if (p[i].g < 0.f) p[i].g = 0.f;
		if (p[i].b > 0.f) p[i].b -= 0.0005f; if (p[i].b < 0.f) p[i].b = 0.f;

		p[i].posx += p[i].velx/100.f;
		p[i].posy += p[i].vely/10.f;
		p[i].posz += p[i].velz/100.f;

		if (p[i].r==0.f && p[i].g==0.f && p[i].b==0.f && p[i].a==0.f)
			particules_start++;

		if (p[i].r>0.f && p[i].g>0.f && p[i].b>0.f /*&& p[i].a>0*/) {
			glColor4f(p[i].r, p[i].g, p[i].b, p[i].a);


			QuadBillboarded(1.0f, p[i].posx, p[i].posy, p[i].posz);  // Modif de la taille ici !!!!
		}
	}
}

void DrawParticles_Emitter(float size, float x, float y, float z)
{
	Prepare_Billboarding();
	QuadBillboarded(size, x, y, z);
}
