/*
 * 	---------------- MoJo engine --------------
 *   		---- Basic Game Engine ----
 *
 * Author: Yann PARMENTIER <kohai@kohaistyle.com>
 *
 * ALL RIGHTS RESERVED
 *
 *	Uses
 * 			DMFloader  		( www.delgine.com )
 * 			GLFW 				( glfw.sourceforge.net )
 *			Fmod Sound API 		( www.fmod.org )
 *
 * To compile this project you must include the following libraries:
 * wlib.lib uuid.lib fmodlcc.lib glfw.lib glu32.lib ole32.lib olepro32.lib opengl32.lib
 * You need also the header file glfw.h in your GL/ compiler directory.
 *
 * File header: mojoSound.c
 *
 */


#include 	<string.h>
#include 	<stdlib.h>
#include 	<GL/glfw.h>
#include 	<GL/glext.h>
#include 	<inc/fmod.h>

#include 	"mojomain.h"


/**********************************************************
 *
 * VARIABLES DECLARATION
 *
 *********************************************************/





int				mojoSoundInit( void )
{


    if (!FSOUND_Init(44100, 32, 0))
    {
        //printf("%s\n", FMOD_ErrorString(FSOUND_GetError()));
        return 1;
    }

	return 0;

}



int				mojoSoundClose( void )
{


    FSOUND_Close;

	return 0;
}




int 			mojoSoundLoad( char *filename, int sndId)
{

	char 	tmp[25],ext[4];
	char	path[50];


	strcpy(path,mojoResDir);
	strcat(path,filename);

    soundSlot[sndId].sndPtr = FSOUND_Sample_Load(FSOUND_FREE, path, FSOUND_NORMAL | FSOUND_HW3D /*| FSOUND_LOOP_NORMAL*/, 0, 0);

	if(soundSlot[sndId].sndPtr == NULL )
		return 1;


		//if(success == 1)
		//{
			//soundSlot[sndId].sndLoaded = 1;
			//strcpy( soundSlot[sndId].sndName, strlwr(tmp));
			//soundSlot[sndId].sndId = sndId;

		//}

	return 0;
}



int				mojoSoundGetFreeId( void )
{

	int i;

	for(i=0;i<MAX_SOUND_SLOTS;i++)
	{

		if(soundSlot[i].sndLoaded==0)
			return i;

	}

	return -1;
}



void 			mojoSoundSet( int slot, char *name, int sndId )
{
		soundSlot[slot].sndLoaded = 1;
		strcpy( soundSlot[slot].sndName, strlwr(name));
		soundSlot[slot].sndId = sndId;

}



int 			mojoSoundGetSoundId( char *name )
{

	int		id = -1, i;

	for(i=0; i< MAX_TEX_SLOTS; i++){
		if(!strcmpi(soundSlot[i].sndName,strlwr(name))){
			id = i;
			break;
		}
	}


	return id;
}


void 			mojoSoundFreeSound( int slot )
{

		//glDeleteTextures(1,&soundSlot[slot].sndId);
		soundSlot[slot].sndLoaded = 0;
		soundSlot[slot].sndName[0] = '\0';
		soundSlot[slot].sndId = 0;

}




void 			mojoSoundFreeList( void )
{
	int i;

	for(i=0; i< MAX_SOUND_SLOTS; i++){

		if(soundSlot[i].sndLoaded)
		{

			mojoSoundFreeSound( i );
		}
	}

}



