// Timer.h

#ifndef _TIMER_H_
#define _TIMER_H_

#include <windows.h> // for BOOL

typedef struct _Timer
{
	//	Time frequency
	long long frequency;

	//	Timer resolution
	float resolution;

	//	Multimedia timer variables for start times
	unsigned mmTimerStart;

	//	Performance counter timer variables for start times
	long long pcTimerStart;

	//	Using performance counter timer or multimedia timer?
	BOOL usePerformanceCounter;

	//	How many times the timer has been paused successively
	int pauseCount;

	//	When the timer was paused
	double pauseTime;

}TIMER;

TIMER * Timer_GetNewTimer(void);
void Timer_Timer(TIMER * tim);
void Timer_Reset(TIMER * tim);
double Timer_GetTime(TIMER * tim);
void Timer_Pause(TIMER * tim);
void Timer_Unpause(TIMER * tim);


#endif	// _TIMER_H_
